'---------------------------------------------------------------------------
'
'                                  PeInfo
'                            By Randall L Glass
'                            Public Domain 20002
'                            
'----------------------------------------------------------------------------
' This program PE executable file infomation.Shows the exports and imports,
' and other info.
'---------------------------------------------------------------------------
'
'For more info use google to find pe1.zip. This contains LUEVELSMEYER's
' pe.txt document on pe file format.
'----------------------------------------------------------------------------


DEFINT A-Z

%DMPI = &H2A0029

TYPE IMAGE_DOS_HEADER          ' DOS .EXE header
  e_magic AS STRING * 2        ' Magic number
  e_cblp AS WORD               ' Bytes on last page of file
  e_cp AS WORD                 ' Pages in file
  e_crlc AS WORD               ' Relocations
  e_cparhdr AS WORD            ' Size of header in paragraphs
  e_minalloc AS WORD           ' Minimum extra paragraphs needed
  e_maxalloc AS WORD           ' Maximum extra paragraphs needed
  e_ss AS WORD                 ' Initial (relative) SS value
  e_sp AS WORD                 ' Initial SP value
  e_csum AS WORD               ' Checksum
  e_ip AS WORD                 ' Initial IP value
  e_cs AS WORD                 ' Initial (relative) CS value
  e_lfarlc AS WORD             ' File address of relocation table
  e_ovno AS WORD               ' Overlay number
  e_res AS STRING * 8          ' Reserved words
  e_oemid AS WORD              ' OEM identifier (for e_oeminfo)
  e_oeminfo AS WORD            ' OEM information; e_oemid specific
  e_res2 AS STRING * 20        ' Reserved words
  e_lfanew AS LONG             ' File address of new exe header
END TYPE

TYPE IMAGE_FILE_HEADER
  Machine AS WORD
  NumberOfSections AS WORD
  TimeDateStamp AS DWORD
  PointerToSymbolTable AS DWORD
  NumberOfSymbols AS DWORD
  SizeOfOptionalHeader AS WORD
  Characteristics AS WORD
END TYPE

TYPE IMAGE_DATA_DIRECTORY
  VirtualAddress AS DWORD
  Size AS DWORD
END TYPE

TYPE IMAGE_OPTIONAL_HEADER
  '
  ' Standard fields.
  '
  Magic AS WORD
  MajorLinkerVersion AS BYTE
  MinorLinkerVersion AS BYTE
  SizeOfCode AS DWORD
  SizeOfInitializedData AS DWORD
  SizeOfUninitializedData AS DWORD
  AddressOfEntryPoint AS DWORD
  BaseOfCode AS DWORD
  BaseOfData AS DWORD

  '
  ' NT additional fields.
  '
  ImageBase AS DWORD
  SectionAlignment AS DWORD
  FileAlignment AS DWORD
  MajorOperatingSystemVersion AS WORD
  MinorOperatingSystemVersion AS WORD
  MajorImageVersion AS WORD
  MinorImageVersion AS WORD
  MajorSubsystemVersion AS WORD
  MinorSubsystemVersion AS WORD
  Reserved1 AS DWORD
  SizeOfImage AS DWORD
  SizeOfHeaders AS DWORD
  CheckSum AS DWORD
  Subsystem AS WORD
  DllCharacteristics AS WORD
  SizeOfStackReserve AS DWORD
  SizeOfStackCommit AS DWORD
  SizeOfHeapReserve AS DWORD
  SizeOfHeapCommit AS DWORD
  LoaderFlags AS DWORD
  NumberOfRvaAndSizes AS DWORD
  DataDirectory AS STRING * 128
END TYPE

TYPE IMAGE_NT_HEADERS
  Signature AS STRING *2
  Signature2 AS STRING * 2
  FileHeader AS IMAGE_FILE_HEADER
  OptionalHeader AS IMAGE_OPTIONAL_HEADER
END TYPE

TYPE IMAGE_EXPORT_DIRECTORY
  Characteristics AS DWORD
  TimeDateStamp AS DWORD
  MajorVersion AS WORD
  MinorVersion AS WORD
  NAMEBase AS DWORD
  OrdinalBase AS DWORD
  NumberOfFunctions AS DWORD
  NumberOfNames AS DWORD
  AddressOfFunctions AS DWORD
  AddressOfNames AS DWORD
  AddressOfNameOrdinals AS DWORD
END TYPE

' Section header format.

UNION MiscUnionISH
  PhysicalAddress AS DWORD
  VirtualSize AS DWORD
END UNION

TYPE IMAGE_SECTION_HEADER
  SectName AS STRING * 8
  Misc AS MiscUnionISH
  VirtualAddress AS DWORD
  SizeOfRawData AS DWORD
  PointerToRawData AS DWORD
  PointerToRelocations AS DWORD
  PointerToLinenumbers AS DWORD
  NumberOfRelocations AS WORD
  NumberOfLinenumbers AS WORD
  Characteristics AS DWORD
END TYPE

TYPE IMAGE_IMPORT_DESCRIPTOR
   OrginalFirstThunk AS DWORD
   TimeDateStamp AS DWORD
   ForwarderChain AS DWORD
   DllName AS DWORD
   FirstThunk AS DWORD
END TYPE

DECLARE SUB ExportsImport(DllName$)
DECLARE FUNCTION FormTable$(S$,VarPos%,ANY,VarType$)
SHARED NumberOfSections??
SHARED RvaSectionAddress???(),FileSectionAddress???()
Cmd$ = UCASE$(TRIM$(COMMAND$))
FileName$ = DIR$(Cmd$)
SELECT CASE Cmd$
 CASE ""
	PRINT "PeInfo Syntax: Peinfo PeFileName"
 CASE "?"
	PRINT "PeInfo Syntax: Peinfo PeFileName"
 CASE FileName$
	ExportsImport Cmd$
 CASE ELSE
	PRINT "PeInfo Syntax: Peinfo PeFileName"
END SELECT

END

SUB ExportsImport(DllName$)
DIM DosHeader AS IMAGE_DOS_HEADER
DIM Header AS IMAGE_NT_HEADERS
DIM ExportHeader AS IMAGE_EXPORT_DIRECTORY
DIM AddrFunc AS DWORD PTR
DIM Routine AS ASCIIZ * 100
DIM RoutineAddress AS DWORD PTR
DIM DirInfo AS IMAGE_DATA_DIRECTORY PTR
DIM Directories$(14)
DIM ImportHeader AS IMAGE_IMPORT_DESCRIPTOR
DIM ImportNullHeader AS IMAGE_IMPORT_DESCRIPTOR
DIM C AS STRING * 1


DLLName$ = UCASE$(DLLName$)

SHARED NumberOfSections??

FOR I% = 0 TO 15
	READ Directories$(I%)
NEXT I%

IF DIR$(DllName$) = "" THEN PRINT "DllName$ not Found":END
CLS
OPEN DllName$ FOR BINARY AS #1
GET #1,,DosHeader                'Get Dos Header
IF DosHeader.e_magic <> "MZ" THEN PRINT "Not A Portable Executable":EXIT SUB

SEEK #1,DosHeader.e_lfanew      'e_lfanew = PE File Header Offset
GET #1,,Header
IF Header.Signature <> "PE" THEN PRINT "Not A Portable Executable":EXIT SUB
  STDOUT FormTable$("Portable Executable starts at",40,DosHeader.e_lfanew,"&")
  STDOUT "PE Signature                              " + Header.Signature + WordHex$(CVWRD(Header.Signature2))

  STDOUT FormTable$("Cpu Type",40,Header.FileHeader.Machine,"??");
  SELECT CASE Header.FileHeader.Machine
   CASE 0
   	 STDOUT " UNKNOWN"
   CASE &H014C
         STDOUT " Intel 386"
   CASE &H014D
         STDOUT " Intel 486"
   CASE &H014E
         STDOUT " Pentum"
   CASE ELSE
         STDOUT " Mips"
  END SELECT

  STDOUT FormTable$("Number Of Sections" ,40,Header.FileHeader.NumberOfSections,"??")
  STDOUT FormTable$("Time Date Stamp",40,Header.FileHeader.TimeDateStamp,"???") + " " + Unix2Date$(Header.FileHeader.TimeDateStamp)
  STDOUT FormTable$("Symbol Table",40,Header.FileHeader.PointerToSymbolTable,"???")
  STDOUT FormTable$("Number of Symbols",40,Header.FileHeader.NumberOfSymbols,"???")
  STDOUT FormTable$("Optional header size",40,Header.FileHeader.SizeOfOptionalHeader,"??")
  STDOUT FormTable$("Characteristics",40,Header.FileHeader.Characteristics,"??")

  FOR I% = 0 TO 15
	  FileType% = -1
	  IF BIT(Header.FileHeader.Characteristics,I%) THEN
          	  FileType% = I%

		  SELECT CASE FileType%
		  CASE 1
	          	  STDOUT "    Executable"
	           CASE 2
	                  STDOUT "    Lines Numbers Stripped"
	           CASE 3
	                  STDOUT "    Local Symbols Stripped"
	           CASE 4
	                  STDOUT "    Trimmed Working Set"
                   CASE 8
			  STDOUT "    32 Bit Word Machine"
	           CASE 9
	                  STDOUT "    Debug Info Stripped"
		  CASE 12
	          	  STDOUT "    Driver"
		  CASE 13
	          	  STDOUT "    Dll"
		  END SELECT
  	END IF
  NEXT I%

  STDOUT FormTable$("Magic",40,Header.OptionalHeader.Magic,"??")
  STDOUT "Linker Version                              "+ TRIM$(STR$(Header.OptionalHeader.MajorLinkerVersion)) + "." + _
  LTRIM$(STR$(Header.OptionalHeader.MinorLinkerVersion))
  STDOUT FormTable$("Code Size",40,Header.OptionalHeader.SizeOfCode,"???")
  STDOUT FormTable$("Initialized Data Size",40,Header.OptionalHeader.SizeOfInitializedData,"???")
  STDOUT FormTable$("Uninitialized Data Size",40,Header.OptionalHeader.SizeOfUninitializedData,"???")
  STDOUT FormTable$("Entry Point",40,Header.OptionalHeader.AddressOfEntryPoint,"???")
  STDOUT FormTable$("Base Of Code",40,Header.OptionalHeader.BaseOfCode,"???")
  STDOUT FormTable$("Base Of Data",40,Header.OptionalHeader.BaseOfData,"???")

NumberOfSections?? = Header.FileHeader.NumberOfSections
ImageBase??? = Header.OptionalHeader.ImageBase

STDOUT FormTable$("Image Base",40,ImageBase???,"???")
STDOUT FormTable$("Section Alignment",40,Header.OptionalHeader.SectionAlignment,"???")
STDOUT FormTable$("File Alignment",40,Header.OptionalHeader.FileAlignment,"???")


STDOUT "Operating System Version" + "                     " + TRIM$(STR$(Header.OptionalHeader.MajorOperatingSystemVersion)) + _
  "." + LTRIM$(STR$(Header.OptionalHeader.MinorOperatingSystemVersion))

STDOUT "Image Version" + "                                " + TRIM$(STR$(Header.OptionalHeader.MajorImageVersion)) + "." + TRIM$(STR$(Header.OptionalHeader.MinorImageVersion))
STDOUT "SubSystem Version" + "                            " + TRIM$(STR$(Header.OptionalHeader.MajorSubsystemVersion)) + "." + TRIM$(STR$(Header.OptionalHeader.MinorSubsystemVersion))
STDOUT FormTable$("Resevred",40,Header.OptionalHeader.Reserved1,"???")
STDOUT FormTable$("Image Size",40,Header.OptionalHeader.SizeOfImage,"???")
STDOUT FormTable$("Header Size",40,Header.OptionalHeader.SizeOfHeaders,"???")
STDOUT FormTable$("CheckSum",40,Header.OptionalHeader.CheckSum,"???")
STDOUT FormTable$("SubSystem",40,Header.OptionalHeader.Subsystem,"??")

SELECT CASE Header.OptionalHeader.Subsystem
CASE 0
         STDOUT "         UnKnown"
CASE 1
         STDOUT "         Native {Driver}"

CASE 2
         STDOUT "         Windows Gui"
CASE 3
         STDOUT "         Windows Console"
CASE 5
         STDOUT "         OS/2 Console"
CASE 7
         STDOUT "         PostFIx Console"
END SELECT

STDOUT "Dll Flag Bits                                  " + TRIM$(BIN$(Header.OptionalHeader.DllCharacteristics)) + "B"
STDOUT FormTable$("Stack Reserved Size",40,Header.OptionalHeader.SizeOfStackReserve,"???")
STDOUT FormTable$("Stack Commit Size",40,Header.OptionalHeader.SizeOfStackCommit,"???")
STDOUT FormTable$("Heap Reserved Size",40,Header.OptionalHeader.SizeOfHeapReserve,"???")
STDOUT FormTable$("Heap Commit Size",40,Header.OptionalHeader.SizeOfHeapCommit,"???")
STDOUT FormTable$("Loader Flags",40,Header.OptionalHeader.LoaderFlags,"???")
STDOUT FormTable$("Number of Directories",40,Header.OptionalHeader.NumberOfRvaAndSizes,"???")
STDOUT

STDOUT STRING$(79,"-")
STDOUT "Directory Names" + SPACE$(25) + "VirtAddr   VirtSize"
STDOUT STRING$(79,"-")
DirInfo = VARPTR32(Header.OptionalHeader.DataDirectory)
FOR N% = 0  TO Header.OptionalHeader.NumberOfRvaAndSizes -1
	STDOUT FormTable$(Directories$(N%),40,@DirInfo[N%].VirtualAddress,"???");
        STDOUT "   " + DHEX$(@DirInfo[N%].Size)
NEXT N%

DIM SectionHeader AS IMAGE_SECTION_HEADER

DIM RvaSectionAddress???(NumberOfSections??+1),FileSectionAddress???(NumberOfSections??)
SHARED RvaSectionAddress???(),FileSectionAddress???()

STDOUT
STDOUT STRING$(79,"-")
STDOUT "Section Table"
STDOUT STRING$(79,"-")
FOR I% = 1 TO NumberOfSections??
	GET #1,,SectionHeader  'ptr IMAGE_SECTION_HEADER
        STDOUT
        STDOUT USING$("##",I%) + " " + SectionHeader.SectName
        STDOUT
	STDOUT FormTable$("VirtualAddress RVA",40,SectionHeader.VirtualAddress,"???")
	STDOUT FormTable$("Virtual Memeory Size",40,SectionHeader.Misc,"???")
	STDOUT FormTable$("File Offset to Raw Data",40,SectionHeader.PointerToRawData,"???")
	STDOUT FormTable$("Size of Raw Data",40,SectionHeader.SizeOfRawData,"???")
	STDOUT FormTable$("Characteristics",40,SectionHeader.Characteristics,"???")
        STDOUT
        GOSUB  SectionCharacteristics
        STDOUT
        STDOUT FormTable$("Relocation Offset",40,SectionHeader.PointerToRelocations,"???")
        STDOUT FormTable$("Number of Relocations",40,SectionHeader.NumberOfRelocations,"??")
        STDOUT FormTable$("Line Number Offset",40,SectionHeader.PointerToLinenumbers,"???")
        STDOUT FormTable$("Number of LineNumbers",40,SectionHeader.NumberOfLinenumbers,"??")
        STDOUT
	RvaSectionAddress???(I%) = SectionHeader.VirtualAddress
	FileSectionAddress???(I%) = SectionHeader.PointerToRawData
NEXT I%
STDOUT
STDOUT STRING$(79,"-")

RVA??? =  @DirInfo[0].VirtualAddress

FilePtr??? = RVAToFileMap???(RVA???)
SEEK #1,FilePtr???
GET #1,,ExportHeader

NumberOfFunctions??? = ExportHeader.NumberOfFunctions
OrdinalBase??? = ExportHeader.OrdinalBase
NumberOfNames??? = ExportHeader.NumberOfNames
AddressOfFunctions??? = ExportHeader.AddressOfFunctions
AddressOfNames??? = ExportHeader.AddressOfNames
AddressOfNameOrdinals??? = ExportHeader.AddressOfNameOrdinals

DIM FunctionArray???(NumberOfFunctions???)
DIM NameArray???(NumberOfFunctions???)
DIM OrdinalsArray??(NumberOfFunctions???)
DIM OrdinalsNameArray??(NumberOfFunctions???)
DIM RoutineName$(NumberOfNames???)

FilePtr??? = RVAToFileMap???(AddressOfFunctions???)
SEEK #1,FilePtr???
FOR I% = 0 TO NumberOfFunctions??? -1
	GET #1,,FunctionArray???(I%)
NEXT I%

FilePtr??? = RVAToFileMap???(AddressOfNames???)
SEEK #1,FilePtr???

FOR I% = 0 TO NumberOfNames??? -1
	GET #1,,NameArray???(I%)
NEXT I%

FilePtr??? = RVAToFileMap???(AddressOfNameOrdinals???)
SEEK #1,FilePtr???

FOR I% = 0 TO NumberOfFunctions??? -1
	GET #1,,OrdinalsNameArray??(I%)
        Index% = OrdinalsNameArray??(I%)
	OrdinalsArray??(Index%) = 1
NEXT I%

FilePtr??? = RVAToFileMap???(AddressOfNames???)
SEEK #1,FilePtr???
FOR I% = 0 TO NumberOfNames??? -1
	FilePtr??? = RVAToFileMap???(NameArray???(I%))
	SEEK #1,FilePtr???
        GET #1,,Routine
	RoutineName$(I%) = Routine
NEXT I%

IF NumberOfFunctions??? > 0 THEN
	STDOUT "Ord = Export Ordinal."
	STDOUT "Index = Ordinal - OrdinalBase."
	STDOUT "Index refers to Index of Function Address Array."
	STDOUT "NameIndex refers to Index of Name Address Location Array."
	STDOUT "Number after PE File name is Ordinal Number."
	STDOUT
	STDOUT
	STDOUT " Exp Addr  NameIndex  Ord  Export Name" + " by " + DllName$ + " - " + Unix2Date$(ExportHeader.TimeDateStamp)
	STDOUT STRING$(79,"-")
END IF

FOR I?? = 0 TO NumberOfNames??? -1
        Index?? = OrdinalsNameArray??(I??)
        Ordinal?? = Index?? + OrdinalBase???
	STDOUT " " + DHex$(FunctionArray???(Index??)) + "   " + USING$("####",I??)  + "     " + USING$("####",Ordinal??) + "  " + RoutineName$(I??)
NEXT I??

MainDllName$ = EXTRACT$(DllName$,".")

FOR Index?? = 0 TO NumberOfFunctions??? -1
        IF OrdinalsArray??(Index??) = 0 THEN
        	Ordinal?? = Index?? + OrdinalBase???
		STDOUT " " + DHex$(FunctionArray???(Index??)) + "    NA   " + "    Ord  " + MainDllName$ + "." + LTRIM$(STR$(Ordinal??))
        END IF
NEXT INDEX??


IF @DirInfo[1].Size > 0 THEN

	STDOUT
	STDOUT
	STDOUT "Imp Adr = Address in PE File Memory Image."
	STDOUT "This address contains the relative address of routine in import PE File."
	STDOUT "NameIndex refers to Index of Name Address Location Array in import PE File."

	RVA??? = @DirInfo[1].VirtualAddress
	FilePtr??? = RVAToFileMap???(RVA???)
	SEEK #1,FilePtr???
	DO
		DLLString$ = ""
		BoundArray% = 0
		GET #1,,ImportHeader
		IF ImportHeader = ImportNullHeader THEN EXIT LOOP
	        NextImportHeader??? = SEEK(1)
	        IF ImportHeader.TimeDateStamp <> 0 THEN BoundArray% = 1
		FilePtr??? = RVAToFileMap???(ImportHeader.DLLName)
		SEEK #1,FilePtr???
                DLLString$ = UCASE$(AsciizName$(1))
	        DLLStringMain$ = EXTRACT$(DLLString$,".")
                STDOUT
		STDOUT STRING$(79,"-")

                IF (ImportHeader.OrginalFirstThunk <> 0) AND (ImportHeader.TimeDateStamp <> 0) THEN
                	STDOUT DLLString$ + " Imports are PreLoaded"
                        STDOUT
                END IF

		STDOUT " Imp Adr   NameIndex " + " Import Name from " + DLLString$ + " - " + Unix2Date$(ImportHeader.TimeDateStamp)
		STDOUT STRING$(79,"-")

		ImportArrayRva??? = ImportHeader.OrginalFirstThunk
		IF ImportHeader.OrginalFirstThunk = 0 THEN
			ImportArrayRva??? = ImportHeader.FirstThunk???
			BoundArray% = 0
	        ELSEIF BoundArray% THEN
			BoundArray??? = ImportHeader.FirstThunk???
			BoundFileArray??? = RVAToFileMap???(BoundArray???)
		END IF

		FilePtr??? = RVAToFileMap???(ImportArrayRva???)
		SEEK #1,FilePtr???
		DO
			DLLRoutine$ = ""
			GET #1,,ImportByNameRva???
	                IF ImportByNameRva??? = 0 THEN EXIT LOOP
	                RvaFileOffset??? = SEEK(1)
			SEEK #1, BoundFileArray???
	                GET #1,,  BoundAddress???
	                INCR BoundFileArray???,4
			FilePtr??? = RVAToFileMap???(ImportByNameRva???)
	                SEEK #1,FilePtr???
	                IF BIT(ImportByNameRva???,31) THEN
		                Ordinal?? = Bits??(ImportByNameRva???)
	                        STDOUT " " + DHEX$(BoundArray???) + "     Ord     " + DllStringMain$ + "." + LTRIM$(STR$(Ordinal??))
	                ELSE
	                        GET #1,,Hint??
				DLLRoutine$ = AsciizName$(1)
				STDOUT " " + DHEX$(BoundArray???) + "    " + USING$("####",Hint??) + "     " + DLLRoutine$
	                END IF
                        INCR BoundArray???,4
			SEEK #1,RvaFileOffset???
		LOOP
	        SEEK  #1,NextImportHeader???
	LOOP
	CLOSE
END IF
EXIT SUB
SectionCharacteristics:
FOR K% = 0 TO 31
	DataType% = -1
	IF BIT(SectionHeader.Characteristics,K%) THEN
        	DataType% = K%
		SELECT CASE DataType%
		CASE 5
			STDOUT "   Code"
		CASE 6
			STDOUT "   Initalized Data"
		CASE 7
			STDOUT "   UnInitalized Data"
		CASE 9
			STDOUT "   Documentation"
                CASE 11
                	STDOUT "   Remove"
		CASE 12
			STDOUT "   Common Block Data"
                CASE 17
                	STDOUT "   Purgeable"
                CASE 19
                	STDOUT "   Memory PreLoad"
                CASE 24
                	STDOUT "   Extended Relocations"
		CASE 25
			STDOUT "   Discardable"
		CASE 26
			STDOUT "   Non Cachable"
                CASE 27
                        STDOUT "   NotPaged"
                CASE 28
                	STDOUT "   Sharable"
		CASE 29
			STDOUT "   Executable Access"
		CASE 30
			STDOUT "   Read Access"
		CASE 31
			STDOUT "   Write Access"
		END SELECT
	END IF
NEXT K%
RETURN

END SUB

FUNCTION AsciizName$(BYVAL FileHandle%)
DO
	GET$ FileHandle%,1,C$
        IF C$ = CHR$(0) THEN EXIT LOOP
	StringName$ =  StringName$ + C$
LOOP
FUNCTION = StringName$
END FUNCTION


FUNCTION RVAToFileMap???(RVA???)

FOR I% = 1 TO NumberOfSections??
       IF RVA??? >= RvaSectionAddress???(I%) AND RVA??? < RvaSectionAddress???(I%+1) THEN
       		FUNCTION = RVA??? - RvaSectionAddress???(I%) + FileSectionAddress???(I%)
                EXIT FUNCTION
       END IF
NEXT I%
END FUNCTION

FUNCTION DHex$(ANY)
DIM Dmin AS STRING * 4
DIM Dmax AS STRING * 4
FlexChr$ = "0"
Dmin$ = STRING$(4,"0")
Dmax$ = STRING$(4,"0")
D1??? = 0
D2??  = 0

! LES BX,[BP+6]
! MOV AX,ES:[BX]
! MOV D1??,AX
! MOV AX,ES:[BX+2]
! MOV D2??,AX

RSET Dmin$ = HEX$(D1??)
RSET Dmax$ = HEX$(D2??)
DHEX$ = DMax$ + DMin$
FlexChr$ = " "
END FUNCTION

FUNCTION WordHex$(Wd??)
DIM Var4 AS STRING * 4
DIM VarOut AS STRING * 4
FLEXCHR$ = "0"

Var% = 0
! MOV ES,[BP + 8]
! MOV BX,[BP + 6]
! MOV AX,ES:[BX]
! MOV Var%,AX
RSET Var4 = HEX$(Var%)
RSET VarOut = Var4
FUNCTION = VarOut
FLEXCHR$ = " "
END FUNCTION


FUNCTION FormTable$(S$,VarPos%,ANY,VarType$)
DIM Var1 AS STRING * 1
DIM Var4 AS STRING * 4
DIM Var8 AS STRING * 8
DIM VarOut AS STRING * 8
FLEXCHR$ = "0"
Ln% = LEN(S$)
ExtraSpaces% = VarPos% - Ln%
IF ExtraSpaces% > 0 THEN ExtraSpaces$ = SPACE$(ExtraSpaces%)

SELECT CASE VarType$
CASE "?"
 GOSUB VarByte
CASE "??"
 GOSUB VarWord
CASE "???"
 GOSUB VarDWord
CASE "%"
 GOSUB VarInteger
CASE "&"
 GOSUB VarLong
CASE "!"
 GOSUB VarSingle
CASE "#"
 GOSUB VarDouble
END SELECT

FormTable$ = TRIM$(S$) + ExtraSpaces$ + Var$
EXIT FUNCTION

VarByte:
Var? = 0
! MOV ES,[BP + 12]
! MOV BX,[BP + 10]
! MOV AL,ES:[BX]
! MOV Var?,AL
RSET Var1 = HEX$(Var?)
FlexChr$ = " "
RSET VarOut = Var1
Var$ = VarOut
RETURN

VarWord:
Var?? = 0
! MOV ES,[BP + 12]
! MOV BX,[BP + 10]
! MOV AX,ES:[BX]
! MOV Var??,AX
RSET Var4 = HEX$(Var??)
FlexChr$ = " "
RSET VarOut = Var4
Var$ = VarOut
RETURN

VarDWord:
Var??? = 0
! MOV ES,[BP + 12]
! MOV BX,[BP + 10]
! MOV AX,ES:[BX]
! MOV Var???[0],AX
! MOV AX,ES:[BX+2]
! MOV Var???[2],AX
Var8 = DHEX$(Var???)
FlexChr$ = " "
RSET VarOut = Var8
Var$ = VarOut
RETURN

VarInteger:
Var% = 0
! MOV ES,[BP + 12]
! MOV BX,[BP + 10]
! MOV AX,ES:[BX]
! MOV Var%,AX
RSET Var4 = HEX$(Var%)
FlexChr$ = " "
RSET VarOut = Var4
Var$ = VarOut
RETURN

VarLong:
Var& = 0
! MOV ES,[BP + 12]
! MOV BX,[BP + 10]
! MOV AX,ES:[BX]
! MOV Var&[0],AX
! MOV AX,ES:[BX+2]
! MOV Var&[2],AX
Var8 = DHEX$(Var&)
FlexChr$ = " "
RSET VarOut = Var8
Var$ = VarOut
RETURN

VarSingle:
Var! = 0
! MOV ES,[BP + 12]
! MOV BX,[BP + 10]
! MOV AX,ES:[BX]
! MOV Var![0],AX
! MOV AX,ES:[BX+2]
! MOV Var![2],AX
Var$ = STR$(Var!)
RETURN

VarDouble:
Var# = 0
! MOV ES,[BP + 12]
! MOV BX,[BP + 10]
! MOV AX,ES:[BX]
! MOV Var#[0],AX
! MOV AX,ES:[BX+2]
! MOV Var#[2],AX
! MOV AX,ES:[BX+4]
! MOV Var#[4],AX
! MOV AX,ES:[BX+6]
! MOV Var#[6],AX
Var$ = STR$(Var#)
RETURN

END FUNCTION

FUNCTION StringPtr$(BYVAL SPTR???)
   DIM S AS STRING * 1
   S$ = CHR$(0)
   LOCAL StringEnd??,BytesChecked??
   StringOff?? = 0
   StringSeg?? = 0
   ! CLD
   ! MOV CX,0
   ! SUB CX,1
   ! MOV DI,[BP+6]
   ! MOV StringOff??,DI
   ! MOV ES,[BP+8]
   ! MOV StringSeg??,ES
   ! MOV AL,0
   ! REPNE SCASB
   ! MOV StringEnd??,DI
   ! MOV BytesChecked??,CX
   IF StringEnd?? -1 <> StringOff?? AND BytesChecked?? <> 0 THEN
        Ln?? = StringEnd?? - StringOff?? -1
        AsciizString$ = STRING$(Ln??,0)
        AsciizStringSeg?? = STRSEG(AsciizString$)
        AsciizStringPtr?? = STRPTR(AsciizString$)
        ! MOV SI,StringOff??
        ! MOV ES,AsciizStringSeg??
        ! MOV DI,AsciiZStringPtr??
        ! MOV CX,Ln??
        ! PUSH DS
        ! MOV DS,StringSeg??
        ! REP MOVSB
        ! POP DS
        END IF
   FUNCTION = AsciizString$
END FUNCTION

DATA Export,Import,Resource,Exception,Security,Base Relocation,Debug,CopyRight
DATA GlobalPtr,TLS,Load Config,Bound Import,Import Address Table,Delay Import,Com Descriptor
DATA Reserved

FUNCTION Unix2Date$(TimeDate???)
DIM LastDay???(1969 TO 2150)
FlexChr$ = "0"
DIM Month$(12)
DIM WeekDay$(7)
DIM Year1 AS STRING * 4
DIM Hour1 AS STRING *2
DIM Minute1 AS STRING *2
DIM Second1 AS STRING *2

RESTORE ReadWeekDay
FOR I% = 0 TO 6
	READ WeekDay$(I%)
NEXT I%

ReadWeekDay:
DATA Mon,Tue,Wed,Thu,Fri,Sat,Sun

RESTORE ReadMonth2
FOR I% = 1 TO 12
	READ Month$(I%)
NEXT I%

ReadMonth2:
DATA Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec

Days% = TimeDate??? \ 86400
JulDate& = 2440588 + Days%
WeekDay% = JulDate& MOD 7
Day$ = WeekDay$(WeekDay%)

JulToDate JulDate&,Month&,Day&,Year&
DateTime$ = Day$ + " " + Month$(Month&) + " " + TRIM$(STR$(Day&))
Year1$ = TRIM$(STR$(Year&))

RawSeconds??? = TimeDate??? MOD 86400

Hour% = RawSeconds??? \ 3600
Minute% = RawSeconds???\ 60
Minute% = Minute% MOD 60
Second% = RawSeconds??? MOD 60

RSET Hour1$ = TRIM$(STR$(Hour%))
RSET Minute1$ = TRIM$(STR$(Minute%))
RSET Second1$ = TRIM$(STR$(Second%))

DateTime$ = DateTime$ + " " + Hour1$ + ":" + Minute1$ + ":" + Second1$ + " " + Year1$
FLEXCHR$ = " "
FUNCTION = DateTime$
END FUNCTION

SUB JulToDate (BYVAL Jul&,Month&,Day&,Year&)

  INCR Jul&, 68569
  help& = 4 * Jul& \ 146097
  DECR Jul&, (146097 * help& + 3) \ 4
  TempYear& = 4000 * (Jul& + 1) \ 1461001
  DECR Jul&, 1461 * TempYear& \ 4
  INCR Jul&, 31
  TempMonth& = 80 * Jul& \ 2447

  day& = Jul& - (2447 * TempMonth& \ 80)
  month& = TempMonth& + 2 - (12 * (TempMonth& \ 11))

  year& = 100 * (help& - 49) + TempYear& + (TempMonth& \ 11)
END SUB
